modprobe: ERROR: could not insert 'wl': Package not installed ubuntu14.04.5LTS kernel 3.13.0-165-generic

Bug #1818134 reported by id prism on 2019-02-28
36
This bug affects 5 people
Affects Status Importance Assigned to Milestone
bcmwl (Ubuntu)
Undecided
Unassigned
linux (Ubuntu)
Undecided
Unassigned
shim-signed (Ubuntu)
Undecided
Unassigned

Bug Description

when installing bcmwl-kernel-source to build wl.ko

package version: 6.30.223.248+bdcom-0ubuntu0.2

Expected behavior: kernel module wl.ko loads.
What happened: finit_module returns ENOPKG

My device is: BCM4352 [14e4:43b1] (rev 03)

Happened after latest OS update, downgrading kernel to 164 did not fix, downgrading package did not work.

secure boot mode is off.

A few others are having this issue https://ubuntuforums.org/showthread.php?t=2413303

There is a possibility it is a modaliases problem -- 2015 chagelog states that there was a capitalization problem, but I don't know how to check this.

Andrii Motsok (andigor) wrote :

Also have the issue since yesterday:

modprobe: ERROR: could not insert 'wl': Package not installed

sudo lshw -C network
  *-network UNCLAIMED
       description: Network controller
       product: BCM43142 802.11b/g/n
       vendor: Broadcom Inc. and subsidiaries
       physical id: 0
       bus info: pci@0000:06:00.0
       version: 01
       width: 64 bits
       clock: 33MHz
       capabilities: pm msi pciexpress cap_list
       configuration: latency=0
       resources: memory:f7200000-f7207fff
  *-network
       description: Ethernet interface
       product: RTL810xE PCI Express Fast Ethernet controller
       vendor: Realtek Semiconductor Co., Ltd.
       physical id: 0
       bus info: pci@0000:07:00.0
       logical name: eth0
       version: 07
       serial: 74:e6:e2:3b:6a:b5
       size: 100Mbit/s
       capacity: 100Mbit/s
       width: 64 bits
       clock: 33MHz
       capabilities: pm msi pciexpress msix vpd bus_master cap_list ethernet physical tp mii 10bt 10bt-fd 100bt 100bt-fd autonegotiation
       configuration: autonegotiation=on broadcast=yes driver=r8169 driverversion=2.3LK-NAPI duplex=full firmware=rtl8106e-1_0.0.1 06/29/12 ip=10.0.0.87 latency=0 link=yes multicast=yes port=MII speed=100Mbit/s
       resources: irq:63 ioport:e000(size=256) memory:f7100000-f7100fff memory:f2100000-f2103fff

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in bcmwl (Ubuntu):
status: New → Confirmed
Download full text (3.9 KiB)

I'm also seeing the same problem on a Dell XPS 13 9343 - Wifi is suddenly non-functional, whereas it'd otherwise been working fine for many years (I'm unsure exactly when the problem started, as I mostly use my laptop via wired ethernet, but it's definitely broken within the last couple of weeks).

I've tried booting the previous kernel 3.19.0-80-generic from the grub boot menu, but that also results in non-functional wifi. I've included (hopefully) relevant info below, but please let me know if there's anything else I can do to help.

$ cat /etc/issue
Ubuntu 14.04.5 LTS \n \l

$ uname -a
Linux shyknee 3.19.0-82-generic #90~14.04.1-Ubuntu SMP Thu Feb 23 01:12:44 UTC 2017 x86_64 x86_64 x86_64 GNU/Linux

$ sudo lshw -C network
  *-network UNCLAIMED
       description: Network controller
       product: BCM4352 802.11ac Wireless Network Adapter
       vendor: Broadcom Corporation
       physical id: 0
       bus info: pci@0000:02:00.0
       version: 03
       width: 64 bits
       clock: 33MHz
       capabilities: pm msi pciexpress cap_list
       configuration: latency=0
       resources: memory:f7200000-f7207fff memory:f7000000-f71fffff
  *-network
       description: Ethernet interface
       physical id: 2
       logical name: eth1
       serial: 00:50:b6:0f:5d:ca
       size: 100Mbit/s
       capacity: 100Mbit/s
       capabilities: ethernet physical tp mii 10bt 10bt-fd 100bt 100bt-fd autonegotiation
       configuration: autonegotiation=on broadcast=yes driver=asix driverversion=22-Dec-2011 duplex=full firmware=ASIX AX88772B USB 2.0 Ethernet ip=192.168.0.54 link=yes multicast=yes port=MII speed=100Mbit/s

$ sudo apt-get purge bcmwl-kernel-source
Reading package lists... Done
Building dependency tree
Reading state information... Done
The following packages will be REMOVED
  bcmwl-kernel-source*
0 to upgrade, 0 to newly install, 1 to remove and 0 not to upgrade.
After this operation, 8,045 kB disk space will be freed.
Do you want to continue? [Y/n]
(Reading database ... 483437 files and directories currently installed.)
Removing bcmwl-kernel-source (6.30.223.248+bdcom-0ubuntu0.2) ...
Removing all DKMS Modules
Done.
update-initramfs: deferring update (trigger activated)
Purging configuration files for bcmwl-kernel-source (6.30.223.248+bdcom-0ubuntu0.2) ...
update-initramfs: deferring update (trigger activated)
Processing triggers for initramfs-tools (0.103ubuntu4.11) ...
update-initramfs: Generating /boot/initrd.img-3.19.0-82-generic

$ sudo apt-get install bcmwl-kernel-source
Reading package lists... Done
Building dependency tree
Reading state information... Done
The following NEW packages will be installed
  bcmwl-kernel-source
0 to upgrade, 1 to newly install, 0 to remove and 0 not to upgrade.
Need to get 0 B/1,511 kB of archives.
After this operation, 8,045 kB of additional disk space will be used.
Selecting previously unselected package bcmwl-kernel-source.
(Reading database ... 483359 files and directories currently installed.)
Preparing to unpack .../bcmwl-kernel-source_6.30.223.248+bdcom-0ubuntu0.2_amd64.deb ...
Unpacking bcmwl-kernel-source (6.30.223.248+bdcom-0ubuntu0.2) ...
Setting up bcmwl-kernel-source (6.30....

Read more...

I had a look at my Updates history in Ubuntu Software Centre for the last couple of weeks to see if I could spot any "likely culprits", and I see that on the 18th February the 'dkms' package got bumped from 2.2.0.3-1.1ubuntu5.14.04.9 to 2.2.0.3-1.1ubuntu5.14.04.10 and the 'shim-signed' package got bumped from 1.33.1~14.0.4.3+13-0ubuntu2 to 1.33.1~14.0.4.4+13-0ubuntu2

I found https://askubuntu.com/questions/138284/how-to-downgrade-a-package-via-apt-get and 'apt-cache policy dkms' tells me that only versions 2.2.0.3-1.1ubuntu5.14.04.10 , 2.2.0.3-1.1ubuntu5.14.04.5 and 2.2.0.3-1.1ubuntu5 are available (not 2.2.0.3-1.1ubuntu5.14.04.9), so I tried 'sudo aptitude install dkms=2.2.0.3-1.1ubuntu5.14.04.5` and got the following output:

The following packages will be DOWNGRADED:
  dkms
0 packages upgraded, 0 newly installed, 1 downgraded, 0 to remove and 0 not upgraded.
Need to get 65.4 kB of archives. After unpacking 3,072 B will be freed.
The following packages have unmet dependencies:
 shim-signed : Breaks: dkms (< 2.2.0.3-1.1ubuntu5.14.04.10) but 2.2.0.3-1.1ubuntu5.14.04.5 is to be installed.
The following actions will resolve these dependencies:

     Remove the following packages:
1) shim-signed

Accept this solution? [Y/n/q/?]
The following packages will be DOWNGRADED:
  dkms
The following packages will be REMOVED:
  shim{u} shim-signed{a}
0 packages upgraded, 0 newly installed, 1 downgraded, 2 to remove and 0 not upgraded.
Need to get 65.4 kB of archives. After unpacking 3,743 kB will be freed.
Do you want to continue? [Y/n/?]
Get: 1 http://gb.archive.ubuntu.com/ubuntu/ trusty-security/main dkms all 2.2.0.3-1.1ubuntu5.14.04.5 [65.4 kB]
Fetched 65.4 kB in 0s (469 kB/s)
(Reading database ... 483437 files and directories currently installed.)
Removing shim-signed (1.33.1~14.04.4+13-0ubuntu2) ...
Removing shim (13-0ubuntu2) ...
dpkg: warning: downgrading dkms from 2.2.0.3-1.1ubuntu5.14.04.10 to 2.2.0.3-1.1ubuntu5.14.04.5
(Reading database ... 483420 files and directories currently installed.)
Preparing to unpack .../dkms_2.2.0.3-1.1ubuntu5.14.04.5_all.deb ...
Unpacking dkms (2.2.0.3-1.1ubuntu5.14.04.5) over (2.2.0.3-1.1ubuntu5.14.04.10) ...
Processing triggers for man-db (2.6.7.1-1ubuntu1) ...
Setting up dkms (2.2.0.3-1.1ubuntu5.14.04.5) ...

I then rebooted, and Wifi still wasn't working, so I did 'sudo apt-get purge bcmwl-kernel-source && sudo apt-get install bcmwl-kernel-source' and the Wifi device re-appeared in my Connections menu but said "device not ready" so I did another reboot, and my Wifi is now working again! Hooray :-D

So there's obviously some strange "interaction" between bcmwl-kernel-source, dkms and shim-signed ? I have no idea which package this bug should be filed against / moved to.

krfoley (krfoley) wrote :

I can confirm that the solution provided by Lurchman fixes my problem as well.

id prism (idprism) wrote :

I had to do a little more than this and held several packages to downgraded versions due to dependencies. :(
#sudo apt-mark showhold
dkms
grub-common
grub-efi-amd64-bin
grub2-common
shim
shim-signed

I hope this can be resolved soon so I can un-hold these.

I've done some more investigation this morning, and I think I've narrowed down the problem slightly further. It seems I *can* upgrade 'dkms' (and also install 'shim'), as long as I leave 'shim-signed' uninstalled, although this has a few caveats...

It seems if I 'sudo apt-get purge bcmwl-kernel-source && sudo apt-get install bcmwl-kernel-source' while the 'shim-signed' package is installed, then this builds a "broken" 'wl' module which always gives the message 'modprobe: ERROR: could not insert 'wl': Package not installed' when you try to modprobe it (even after purging 'shim-signed' and rebooting).
However if I 'sudo apt-get purge bcmwl-kernel-source && sudo apt-get install bcmwl-kernel-source' while the 'shim-signed' package is NOT installed, then this builds a 'wl' module which works (even after installing 'shim-signed').

I also updated the BIOS on my XPS 13 9343 to version A19, but this made no difference.

Because installing or uninstalling 'shim-signed' doesn't automatically rebuild DKMS modules, this means you can easily get into some confusing "conflicting" states, e.g. you can purge-and-install 'bcmwl-kernel-source' while 'shim-signed' isn't installed (to get a working 'wl' module), and then install 'shim-signed', and your WiFi will remain working (with the old module), but the next time your DKMS modules get rebuilt your WiFi will suddenly stop working (with the newly-built module).

I know very little about kernel modules and secureboot, but from what I can tell this is possibly a regression caused by https://bugs.launchpad.net/ubuntu/+source/shim-signed/+bug/1748983 interacting with e.g. https://bugs.launchpad.net/ubuntu/+source/bcmwl/+bug/1572659

Steve Langasek (vorlon) wrote :

Please run 'apport-collect -p shim-signed 1818134' to provide further information about the state of SecureBoot on your system.

Changed in shim-signed (Ubuntu):
status: New → Incomplete
Niklas Holm (niklas-holm) wrote :

I have the same problem with the nvidia driver. Updated shim-signed + dkms installed a while ago, worked fine until kernel upgrade triggered dkms rebuild, then the nvidia driver failed to load, "modprobe: ERROR: could not insert 'nvidia': Package not installed". Uninstalling shim-signed, downgrading dkms and reinstalling the drivers solved my issue.

Steve Langasek (vorlon) wrote :

ok, so can someone who's experiencing this bug run the requested command so we can collect more information?

Steve Langasek (vorlon) wrote :

There's a reasonable chance this is an issue with the lockdown kernel patches in Ubuntu 14.04, so opening a task on linux also.

This bug is missing log files that will aid in diagnosing the problem. While running an Ubuntu kernel (not a mainline or third-party kernel) please enter the following command in a terminal window:

apport-collect 1818134

and then change the status of the bug to 'Confirmed'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
Niklas Holm (niklas-holm) wrote :

I would rather not have to deliberately bring my system to a broken state just to run apport-collect. Is there anything else I can do?

Abhi (windmill261) wrote :

Hello,

I had been the suffering with the same issue that Lurchman has found a solution to. I have just now created & activated my Ubuntu One account to thank Lurchman for this.

Thank you....

FaberfoX (faberfox) wrote :

Just want to add that this exact same issue affects Veeam Agent for Linux when dkms builds the veeamsnap module, and @Lurchman's solution works to solve it.

.proc.sys.kernel.moksbstate.disabled: 0
ApportVersion: 2.14.1-0ubuntu3.29
Architecture: amd64
DistroRelease: Ubuntu 14.04
EFIBootMgr:

HibernationDevice: RESUME=UUID=07ff7c9f-3b95-46e0-84ee-17a77e7d60e2
InstallationDate: Installed on 2015-10-02 (1347 days ago)
InstallationMedia: Kubuntu 14.04.2 LTS "Trusty Tahr" - Release amd64 (20150219.1)
IwConfig:
 eth0 no wireless extensions.

 docker0 no wireless extensions.

 lo no wireless extensions.
MachineType: Hewlett-Packard HP Z440 Workstation
Package: shim-signed 1.33.1~14.04.5+13-0ubuntu2
PackageArchitecture: amd64
ProcEnviron:
 TERM=linux
 PATH=(custom, no user)
 XDG_RUNTIME_DIR=<set>
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcFB: 0 EFI VGA
ProcKernelCmdLine: BOOT_IMAGE=/vmlinuz-3.16.0-77-generic.efi.signed root=/dev/mapper/kubuntu--vg-root ro quiet splash nomdmonddf nomdmonisw vt.handoff=7
ProcVersionSignature: Ubuntu 3.16.0-77.99~14.04.1-generic 3.16.7-ckt27
RelatedPackageVersions:
 linux-restricted-modules-3.16.0-77-generic N/A
 linux-backports-modules-3.16.0-77-generic N/A
 linux-firmware 1.127.24
RfKill:

Tags: trusty trusty
Uname: Linux 3.16.0-77-generic x86_64
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups: adm cdrom dip docker lpadmin plugdev sambashare sudo
_MarkForUpload: True
dmi.bios.date: 06/09/2015
dmi.bios.vendor: Hewlett-Packard
dmi.bios.version: M60 v01.58
dmi.board.asset.tag: 990496
dmi.board.name: 212B
dmi.board.vendor: Hewlett-Packard
dmi.board.version: unknown
dmi.chassis.asset.tag: 990496
dmi.chassis.type: 6
dmi.chassis.vendor: Hewlett-Packard
dmi.modalias: dmi:bvnHewlett-Packard:bvrM60v01.58:bd06/09/2015:svnHewlett-Packard:pnHPZ440Workstation:pvr:rvnHewlett-Packard:rn212B:rvrunknown:cvnHewlett-Packard:ct6:cvr:
dmi.product.name: HP Z440 Workstation
dmi.sys.vendor: Hewlett-Packard

tags: added: apport-collected trusty

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

vandebo (vandebo-launchpad) wrote :

I encountered this issue with the nvidia_384 modules.

modprobe: ERROR: could not insert 'nvidia_384': Package not installed

To resolve I did:
apt-get remove --purge shim-signed
apt-get install --reinstall nvidia_384

After those two commands, modprobe succeeded. I ran the apport command.

Changed in shim-signed (Ubuntu):
status: Incomplete → Confirmed
Steve Langasek (vorlon) wrote :

@vandebo, your apport information shows the following:

ProcKernelCmdLine: BOOT_IMAGE=/vmlinuz-3.16.0-77-generic.efi.signed root=/dev/mapper/kubuntu--vg-root ro quiet splash nomdmonddf nomdmonisw vt.handoff=7
ProcVersionSignature: Ubuntu 3.16.0-77.99~14.04.1-generic 3.16.7-ckt27

That appears to be the last released version of the linux-lts-utopic kernel. That kernel is out of security support and has not been updated since 2016. You should upgrade to linux-lts-xenial immediately by installing the linux-signed-generic-lts-xenial package.

@Lurchman, your comment also shows that you are running 3.19.0-82-generic, which is the last released version of the linux-lts-*vivid* kernel, which is also out of security support and has not been updated since February 2017. You should also install linux-signed-generic-lts-xenial immediately.

Please report if you are still experiencing issues once you have a currently-supported version of the kernel on 14.04.

Steve Langasek (vorlon) wrote :

Other commenters, please confirm what kernel version you are seeing this behavior with. If this is not reproducible with either the linux-generic 3.13 kernel or the linux-lts-xenial 4.4 kernel, then it is not going to be fixed.

Note also that Ubuntu 14.04 has reached the end of standard support, so in addition to the other *-lts-* kernels being out of security support for a long time already, the rest of your system is also out of security support unless you have ESM enabled.

vandebo (vandebo-launchpad) wrote :

I've confirmed that the problem went away by upgrading to the xenial kernel -- I reinstall shim-signed, rebooted to the new kernel and it worked. I also reinstalled the nvidia package after rebooting and it still worked.

Should the shim-signed package have a dependency on a kernel that is new enough?

Steve Langasek (vorlon) wrote :

Thanks for confirming.

> Should the shim-signed package have a dependency on a kernel that is new enough?

For better or worse, there is no straightforward way to express such a dependency. But also, the fundamental problem here is not that shim-signed has new requirements. The fundamental problem is that you and other users have been running a kernel that has had no security updates for over 2 years and didn't know it. While it was stated at the time that these kernels would have security support for a limited time and that users who had these kernels installed would not be automatically rolled forward to the next series (as this might introduce regressions in hardware support), evidently this information was not communicated in a way that made it clear to users that they were out of security support.

I will look into what can be done to improve the communication to users in all the usual places that information about security updates are communicated, to let users know they are running unsupported kernels.

Niklas Holm (niklas-holm) wrote :

To be clear, my issue was on the 3.13 kernel line, which is supported. Not that it matters for me anymore because I've since upgraded to 18.04 for which doesn't have this issue.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers